<template>
  <v-card>
    <v-toolbar color="white" height="48">
      <v-row>
        <v-col class="align-self-center ml-2">
          <v-row class="align-center">
            <v-col> Create Dashboard </v-col>
            <v-col align="right" class="pr-6">
              <v-btn
                size="big"
                variant="outlined"
                icon="mdi-close"
                class="open-close-btn-white"
                @click="$emit('close:dialog')"
              />
            </v-col>
          </v-row>
        </v-col>
      </v-row>
    </v-toolbar>
    <v-row>
      <v-col>
        <v-divider />
      </v-col>
    </v-row>
    <v-card-text>
      <v-text-field label="Title" v-model="title"></v-text-field>
    </v-card-text>
    <v-row>
      <v-col>
        <v-divider />
      </v-col>
    </v-row>
    <v-card-actions>
      <v-row>
        <v-col align="left">
          <v-btn @click="$emit('close:dialog')">Cancel</v-btn>
        </v-col>
        <v-col align="right" v-if="!editMode">
          <v-btn color="primary" @click="onCreateHandler">Create</v-btn>
        </v-col>
        <v-col align="right" v-if="editMode">
          <v-btn color="primary" @click="onSaveHander">Save</v-btn>
        </v-col>
      </v-row>
    </v-card-actions>
  </v-card>
</template>

<script>
import { mapState, mapActions } from "pinia";
import { useAppStore } from "@/store/app";

export default {
  name: "FormDashboard",
  emits: ["close.dialog"],
  props: {
    data: { type: Object },
  },
  data() {
    return {
      title: null,
    };
  },
  created() {
    if (this.editMode) {
      this.title = this.data.title;
    }
  },
  computed: {
    ...mapState(useAppStore, ["dashboards"]),
    editMode() {
      if (![undefined,null].includes(this.data) ) {
        //edit mode
        return true;
      }
      // create mode
      return false;
    },
  },
  methods: {
    ...mapActions(useAppStore, ["onAddDashboard", "onSetDashboards"]),
    async onCreateHandler() {
      let array = [...this.dashboards];

      var id = 1;
      if (array.length > 0) {
        console.log("length ");
        id = array.reduce((arr, oId) => {
          return (arr = arr > oId.id ? arr : oId.id);
        });
        id = id + 1;
      }

      this.onAddDashboard({
        id: id,
        title: this.title,
      });
      this.$emit("close:dialog");
    },
    async onSaveHander() {
      let array = [...this.dashboards];
      array = array.map((a) => {
        if (a.id == this.data.id) {
          a.title = this.title;
        }
        return a;
      });

      this.onSetDashboards(array);
      this.$emit("close:dialog");
    },
  },
};
</script>